# $Id: 04_memquery.t,v 1.2 2005/11/25 22:01:38 pythontech Exp $
use strict;
use Test::More tests => 21;

use lib 't/lib';
use DbUtil;

use PythonTech::Triples::Memory;

my $tr = new PythonTech::Triples::Memory();

# Create test data
$tr->add('a', 'b', 'c');
$tr->add('a', 'b', 'd');
$tr->add('a', 'e', 'c');

is($tr->test('a','b','c'), 1, 'simple test');
is($tr->test('a','b','d'), 1, 'simple test');
is($tr->test('a','b','a'), undef, 'test no, resource exists');
is($tr->test('x','b','c'), undef, 'test no, subject unknown');
is($tr->test('a','y','c'), undef, 'test no, predicate unknown');
is($tr->test('a','b','z'), undef, 'test no, object unknown');
is(&qt($tr->query('a','b',undef)), 'c;d', 'query sp?');
is(&qt($tr->query('a',undef,'c')), 'b;e', 'query s?p');
is(&qt($tr->query('a',undef,undef)), 'b,c;b,d;e,c', 'query s??');
is(&qt($tr->query(undef,'b','c')), 'a', 'query ?po');
is(&qt($tr->query(undef,'b',undef)), 'a,c;a,d', 'query ?p?');
is(&qt($tr->query(undef,undef,'d')), 'a,b', 'query ??o');
is(&qt($tr->query(undef,undef,undef)), 'a,b,c;a,b,d;a,e,c', 'query ???');
is(&j($tr->sp2o('a','b')), 'c,d', 'sp2o');
is(&j($tr->sp2o('a','y')), '', 'sp2o no match');
like(scalar($tr->sp2o('a','b')), qr/^(c|d)$/, 'sp2o scalar');
is(&j($tr->po2s('b','d')), 'a', 'po2s');
is(&j(scalar $tr->po2s('b','d')), 'a', 'po2s scalar');
is(&j($tr->po2s('b','z')), '', 'po2s no match');
is(&j($tr->s2p('a')), 'b,e', 's2p');
is(&j($tr->s2p('c')), '', 's2p no match');

$tr = undef;

sub qt {
    join(";", sort map {join(",",@$_)} @_);
}

sub j {join(",",sort @_)}
